IncludeScript("vip/vip/weapon_model.nut");
IncludeScript("vip/vip/vip_buffs.nut");
IncludeScript("vip/vip/vip_headshot.nut");
IncludeScript("vip/vip/vip_nag.nut");
IncludeScript("vip/vip/vip_mediccall.nut");
IncludeScript("vip/vip/vip_fixes.nut");

caneModels <- [worldspawn, worldspawn];

function ConvertToVIP()
{
    EntFireByHandle(SpawnEntityFromTable("info_teleport_destination",
    {
        origin = self.GetCenter(),
        vscripts = "vip/entities/vip_dispenser.nut",
        thinkfunction = "DispenserThink",
        TeamNum = GetFakeTeam(self)
    }), "SetParent", "!activator", 0, self, self);
    self.Regenerate(true);
    if (self.InCond(TF_COND_AIMING))
        RunWithDelay(0.1, function()
        {
            for (local i = 0; i < 10; i++)
            {
                local weapon = GetPropEntityArray(self, "m_hMyWeapons", i);
                if (weapon)
                {
                    self.Weapon_Switch(weapon);
                    return;
                }
            }
        });
}

function RefreshCharacter()
{
    self.SetPlayerClass(TF_CLASS_DEMOMAN);
    SetPropInt(self, "m_Shared.m_bShieldEquipped", 0);
    vipBoostTokens <- vipBoostTokensStart;
    self.KeyValueFromString("targetname", "vip");

    self.SetCustomModelWithClassAnimations(API_GetString("vip_model"));

    local itemsToKill = [];
    for (local item = self.FirstMoveChild(); item != null; item = item.NextMovePeer())
        if (startswith(item.GetClassname(), "tf_we"))
        {
            itemsToKill.push(item);
            local extraVM = GetPropEntity(item, "m_hExtraWearableViewModel");
            if (extraVM)
                itemsToKill.push(extraVM);
        }
    foreach (item in itemsToKill)
        item.Kill();

    self.AddCustomAttribute("voice pitch scale", 0, -1);
    self.AddCustomAttribute("dmg taken from fire reduced", 0.8, -1);
    self.AddCustomAttribute("dmg taken from crit reduced", 0.8, -1);
    self.AddCustomAttribute("increase player capture value", -1, -1);

    self.SetHealth(200);
    self.SetMaxHealth(200);
    self.RemoveCustomAttribute("max health additive bonus");
    self.AddCustomAttribute("max health additive bonus", 25, -1);

    vipBoostTokens = vipBoostTokensMax;

    for(local ent = null; ent = Entities.FindByName(ent, "civ_model*");)
        if (ent && ent.IsValid() && ent.GetOwner() == self)
            ent.Kill();

    local weapon = GivePlayerWeapon(self, "tf_weapon_shovel", 154);
    weapon.AddAttribute("damage bonus HIDDEN", 0.54, -1);
    weapon.AddAttribute("fire rate bonus HIDDEN", 0.625, -1);
    weapon.SetModelSimple(API_GetString("vip_arms_model"));
    weapon.SetCustomViewModelModelIndex(GetModelIndex(API_GetString("vip_arms_model")));
    SetPropInt(weapon, "m_iViewModelIndex", GetModelIndex(API_GetString("vip_arms_model")));
    weapon.DisableDraw();

    local stockViewmodelEnt = GetPropEntity(self, "m_hViewModel");
    stockViewmodelEnt.DisableDraw();
    stockViewmodelEnt.SetModelSimple(API_GetString("vip_arms_model"));

    TrySpawnViewModel(self, API_GetString("vip_arms_model"));
    caneModels[0] = TrySpawnViewModel(self, API_GetString("cane_model"));
    caneModels[1] = TrySpawnWorldModel(self, API_GetString("cane_model"));

    if (!hatWearable || !hatWearable.IsValid())
        hatWearable <- TrySpawnWorldModel(self, API_GetString("vip_hat_model"));
}
OnSelfGameEvent("post_inventory_application_post", 0, RefreshCharacter);

OnSelfGameEvent("player_death", 0, function(params)
{
    FireCustomEvent("vip_death", params);
    self.SetCustomModelWithClassAnimations("");
    CleanEventsFromScope(this);
    CleanTimersFromScope(this);
    CleanDelaysFromScope(this);

    vipPlayers[GetFakeTeam(self)] = null;
});

OnSelfGameEvent("player_disconnect", 0, function()
{
    self.TakeDamageCustom(
        self,
        self,
        self.GetActiveWeapon(),
        Vector(),
        Vector(),
        99999
        0,
        TF_DMG_CUSTOM_TELEFRAG);
});

ConvertToVIP();