::GivePlayerWeapon <- function(player, className, itemID)
{
    local weapon = Entities.CreateByClassname(className);
    NetProps.SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemID);
    NetProps.SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true);
    NetProps.SetPropBool(weapon, "m_bValidatedAttachedEntity", true);
    weapon.SetTeam(player.GetTeam());
    Entities.DispatchSpawn(weapon);

    player.Weapon_Equip(weapon);
    player.Weapon_Switch(weapon);

    return weapon;
}

::TrySpawnViewModel <- function(player, model)
{
    local playerIndex = player.entindex();

    local viewModel = SpawnEntityFromTable("tf_wearable_vm", {
        targetname = "civ_model"
    });
    SetPropBool(viewModel, "m_bForcePurgeFixedupStrings", true);
	viewModel.SetModelSimple(model);
	SetPropEntity(viewModel, "m_hOwnerEntity", player);
	SetPropEntity(viewModel, "m_hOwner", player);
    viewModel.SetOwner(player);
    player.EquipWearableViewModel(viewModel);

	return viewModel;
}

::TrySpawnWorldModel <- function(player, model)
{
    local playerIndex = player.entindex();
    local worldModel = SpawnEntityFromTable("tf_wearable", {
        targetname = "civ_model_worldmodel"
    });
    SetPropBool(worldModel, "m_bForcePurgeFixedupStrings", true);
    SetPropBool(worldModel, "m_bValidatedAttachedEntity", true);
    SetPropBool(worldModel, "m_AttributeManager.m_Item.m_bInitialized", true);
	worldModel.SetModelSimple(model);
    EntFireByHandle(worldModel, "SetParent", "!activator", 0, player, player);
	SetPropEntity(worldModel, "m_hOwnerEntity", player);
	SetPropEntity(worldModel, "m_hOwner", player);
    worldModel.SetOwner(player);

	return worldModel;
}